#include "osconfig.h"
#include <extdll.h>
#include <meta_api.h>

#include "chooker.h"

typedef void (*ED_LoadFromFile_t)(char *);
ED_LoadFromFile_t ED_LoadFromFile_func = NULL;

CHooker g_Hooker;
CHooker* g_pHooker = &g_Hooker;

void ED_LoadFromFile_hook(char* data)
{
	GET_ORIG_FUNC(func);

	int control = 0;
	char* start = strchr(data, '{');

	if(start)
	{
		start++;
		control++;
		while(control)
		{
			if(*start == '{')
				control++;
			else if(*start == '}')
				control--;

			if(*start > 127 || *start < 0)
				*start = '\n';

			start++;
		}
	}

	UTIL_LogPrintf("\n");

	if(func->Restore())
	{
		ED_LoadFromFile_func(data);
		func->Patch();
	}
}

bool module_init()
{
	CFunc* func;

	// Fix ED_LoadFromFile
	ED_LoadFromFile_func = g_pHooker->MemorySearch<ED_LoadFromFile_t>("ED_LoadFromFile", "engine", TRUE);
	if(ED_LoadFromFile_func)
		g_pHooker->CreateHook(ED_LoadFromFile_func, ED_LoadFromFile_hook, TRUE);

	return 1;
}
